readini=ReadFile("config.ini")
Local config[5]
Repeat
	L$=ReadLine(readini)
	If Not Instr(L,";",1)=1 Then i=i+1:config[i]=L
Until Eof(readini)
Global Graphicsx=config[1]
Global graphicsy=config[2]
graphicsd=config[3]
graphicsm=config[4]
MouseLine=config[5]
Global MouseSensivity#=(41-Int(MouseLine))/10.0
Global timer,camera;ONLY FOR DEBUGGING

Graphics3D(Graphicsx,graphicsy,graphicsd,graphicsm)
LN=Input("Level Nr: ")
camera=CreateCamera()
;camlight=CreateLight(2,camera)
MoveMouse Graphicsx/2,graphicsy/2
Global small_font=LoadFont("Illumination.ttf",14)
Global big_font=LoadFont("Illumination.ttf",64,1)
SetFont big_font
Global ItemCount,StartX,StartY,EndX,EndY,W,RW,ZielText$
Global Ground$,GroundDebug$,OldX,OldY,NewX,NewY,setdirection
Global ShowCountWelle$,WellenText$,CountWelle=1,NextLoad,WellenTextShow$
sphere=CreateSphere(8,camera)
ScaleEntity sphere,-10,-10,-10
stex=LoadTexture("startex.bmp")
ScaleTexture stex,0.1,0.1
EntityTexture sphere,stex
EntityOrder sphere,10


Const Detail=100,PF$="Produkt hergestellt, ab zur Auslieferung"
SeedRnd MilliSecs()
timer=CreateTimer(50)

;Spielfeld erstellung
Dim Spielfeld$(11,11,5);KoordinatenNrX;KoordinatenNrY; CoorPosx, CoorPosy, Teil, Teiltyp, Orientation, Sondertyp
Dim Welle$(20,1)

Global PlayBoard=CreateCube()
ScaleEntity PlayBoard,12,12,1
PositionEntity camera,160,200,-400
RotateEntity camera,0,0,0

HidePointer

LoadLevel("Level"+LN+".txt")
PositionEntity PlayBoard,StartX*40,StartY*40,-4
startsecs=MilliSecs()
RotateEntity camera,EntityPitch(camera),EntityYaw(camera),180
Repeat
	TurnEntity sphere,0.2,0.2,0
	RenderWorld
	Starter=Floor((MilliSecs()-StartSecs)/1000)
	If starter=1 Then Text Graphicsx/2,graphicsy/2,"5",1,1
	If starter=2 Then Text Graphicsx/2,graphicsy/2,"4",1,1
	If starter=3 Then Text Graphicsx/2,graphicsy/2,"3",1,1
	If starter=4 Then Text Graphicsx/2,graphicsy/2,"2",1,1
	If starter=5 Then Text Graphicsx/2,graphicsy/2,"1",1,1
	If starter=>6 Then Exit
	Flip 0
	WaitTimer timer
Forever
FlushMouse
MoveMouse Graphicsx/2,graphicsy/2
SetFont small_font
Global LevelStart=MilliSecs()
Repeat
	pickedtile=CameraPick(camera,Graphicsx/2,graphicsy/2)
	If pickedtile<>0 Then
		PickX=EntityX(camera)/40
		PickY=EntityY(camera)/40
	EndIf
	If MouseHit(2) And pickedtile<>0 Then
		BoardX=EntityX(PlayBoard)/40
		BoardY=EntityY(PlayBoard)/40
		If Not (PickX=BoardX And PickY=BoardY) Then
			If Spielfeld(PickX,PickY,3)="1" Or Spielfeld(PickX,PickY,3)="2";Kurve oder L+R
				Spielfeld(PickX,PickY,4)=(Int(Spielfeld(PickX,PickY,4))+1) Mod 4
			EndIf
			If Spielfeld(PickX,PickY,3)="6" Or Spielfeld(PickX,PickY,3)="3";Gerade
				Spielfeld(PickX,PickY,4)=(Int(Spielfeld(PickX,PickY,4))+1) Mod 2
			EndIf
			TurnEntity pickedtile,0,0,90
		EndIf
	EndIf
	movement3(camera,0,1)
	MoveBoard
	TurnEntity sphere,0.2,0.2,0
	If KeyHit(2) Then WFMode=1-WFMode
	If KeyHit(3) Then Stop
	If KeyHit(4) Then DebugMode
	WireFrame WFMode
	RenderWorld
	;Text 0,0,TrisRendered()
	If Not ShowCountWelle$=PF Then ShowCountWelle$="Vorgabe: Welle "+CountWelle+"/"+W
	Text 0,20,ShowCountWelle$
	Text 60,40,WellenText
	Text 0,60,"Bisher :"
	Text 60,60,ZielText
	Text 0,80,"Punkt 1: Rot"
	Text 0,100,"Punkt 2: Grn"
	Text 0,120,"Punkt 3: Blau"
	Text 0,140,"Punkt 4: Gelb"
	Text 0,160,"Punkt 5: Trkis"
	;Text 0,40,"Board "+EntityX(PlayBoard)+","+EntityY(PlayBoard)
	;Text 0,60,"ground "+Spielfeld(NewX,NewY,0)+","+Spielfeld(NewX,NewY,1)
	;Text 0,80,Spielfeld(NewX,NewY,4)
	;Text 0,100,vonrichtung
	Rect Graphicsx/2-1,graphicsy/2-1,2,2
	MoveMouse Graphicsx/2,graphicsy/2
	Flip 0
	WaitTimer timer
Until KeyDown(1)
End

Function DebugMode()
	Repeat
		Movement(camera)
		If KeyHit(2) Then WFMode=1-WFMode
		If KeyHit(3) Then Stop
		WireFrame WFMode
		RenderWorld
		Flip 0
		WaitTimer timer
	Until KeyHit(59)
End Function
Function NW(a)
	SetFont big_font
	Text Graphicsx/2,graphicsy/2,"Wave "+a,1,1
	Flip
	ms=MilliSecs()
	Repeat
		If MilliSecs()>ms+4000 Then Exit
	Forever
	SetFont small_font
End Function
Function MoveBoard()
	;Spielfeld(x,y,5)=Sondertyp Keiner(0) Start(1) Ziel(2) Point1(3) Point2(4) Point3(5) Point4(6) Point5(7)
	OldX=NewX
	OldY=NewY
	NewX=EntityX(PlayBoard)/40
	NewY=EntityY(PlayBoard)/40
	Ground$=Spielfeld(NewX,NewY,3)
	If Int(EntityY(PlayBoard))<-1 Then TurnEntity PlayBoard,0,0,180
	If Int(EntityY(PlayBoard))>440 Then TurnEntity PlayBoard,0,0,180
	If Int(EntityX(PlayBoard))<-1 Then TurnEntity PlayBoard,0,0,180
	If Int(EntityX(PlayBoard))>440 Then TurnEntity PlayBoard,0,0,180
	
	If OldX<>NewX Or OldY<>NewY Then
		Test$=Spielfeld(NewX,NewY,5)
		Select Spielfeld(NewX,NewY,5)
			Case "2"
				If ShowCountWelle$=PF Then RuntimeError "Level Completed in "+((MilliSecs()-LevelStart)/1000)+"s"
			Case "3"
				If NextLoad=1 Then
					ZielText=ZielText+NextLoad
					If Len(ZielText)=Welle(CountWelle,0) Then
						CountWelle=CountWelle+1
						NW(CountWelle)
						WellenText=Welle(CountWelle,1)
						ZielText=""
					EndIf
					If CountWelle<=W Then
						NextLoad=Mid(Welle(CountWelle,1),Len(ZielText)+1,1)
					Else
						ShowCountWelle$=PF
					EndIf
				EndIf
			Case "4"
				If NextLoad=2 Then
					ZielText=ZielText+NextLoad
					If Len(ZielText)=Welle(CountWelle,0) Then
						CountWelle=CountWelle+1
						NW(CountWelle)
						WellenText=Welle(CountWelle,1)
						ZielText=""
					EndIf
					If CountWelle<=W Then
						NextLoad=Mid(Welle(CountWelle,1),Len(ZielText)+1,1)
					Else
						ShowCountWelle$=PF
					EndIf
				EndIf
			Case "5"
				If NextLoad=3 Then
					ZielText=ZielText+NextLoad
					If Len(ZielText)=Welle(CountWelle,0) Then
						CountWelle=CountWelle+1
						NW(CountWelle)
						WellenText=Welle(CountWelle,1)
						ZielText=""
					EndIf
					If CountWelle<=W Then
						NextLoad=Mid(Welle(CountWelle,1),Len(ZielText)+1,1)
					Else
						ShowCountWelle$=PF
					EndIf
				EndIf
			Case "6"
				If NextLoad=4 Then
					ZielText=ZielText+NextLoad
					If Len(ZielText)=Welle(CountWelle,0) Then
						CountWelle=CountWelle+1
						NW(CountWelle)
						WellenText=Welle(CountWelle,1)
						ZielText=""
					EndIf
					If CountWelle<=W Then
						NextLoad=Mid(Welle(CountWelle,1),Len(ZielText)+1,1)
					Else
						ShowCountWelle$=PF
					EndIf
				EndIf
			Case "7"
				If NextLoad=5 Then
					ZielText=ZielText+NextLoad
					If Len(ZielText)=Welle(CountWelle,0) Then
						CountWelle=CountWelle+1
						NW(CountWelle)
						WellenText=Welle(CountWelle,1)
						ZielText=""
					EndIf
					If CountWelle<=W Then
						NextLoad=Mid(Welle(CountWelle,1),Len(ZielText)+1,1)
					Else
						ShowCountWelle$=PF
					EndIf
				EndIf
		End Select
		If Int(EntityX(PlayBoard))>Spielfeld(NewX,NewY,0) Then vonrichtung$="L";:RotateEntity PlayBoard,0,0,90;kommt von links
		If Int(EntityX(PlayBoard))<Spielfeld(NewX,NewY,0) Then vonrichtung$="R";:RotateEntity PlayBoard,0,0,270;kommt von rechts
		If Int(EntityY(PlayBoard))>Spielfeld(NewX,NewY,1) Then vonrichtung$="U";:RotateEntity PlayBoard,0,0,180;kommt von Unten
		If Int(EntityY(PlayBoard))<Spielfeld(NewX,NewY,1) Then vonrichtung$="O";:RotateEntity PlayBoard,0,0,0;kommt von oben
		PositionEntity PlayBoard,Int(EntityX(PlayBoard)),Int(EntityY(PlayBoard)),-4
		If Right$(Int(EntityX(PlayBoard)),1)="1" Then PositionEntity PlayBoard,EntityX(PlayBoard)-1,EntityY(PlayBoard),-4
		If Right$(Int(EntityY(PlayBoard)),1)="1" Then PositionEntity PlayBoard,EntityX(PlayBoard),EntityY(PlayBoard)-1,-4
		If Right$(Int(EntityX(PlayBoard)),1)="9" Then PositionEntity PlayBoard,EntityX(PlayBoard)+1,EntityY(PlayBoard),-4
		If Right$(Int(EntityY(PlayBoard)),1)="9" Then PositionEntity PlayBoard,EntityX(PlayBoard),EntityY(PlayBoard)+1,-4
		darfRichtung=Spielfeld(NewX,NewY,4)
		Select Ground
			Case 5,0;Freiflche
				If vonrichtung="O" Then RotateEntity PlayBoard,0,0,180:setdirection=3
				If vonrichtung="U" Then RotateEntity PlayBoard,0,0,0:setdirection=3
				If vonrichtung="L" Then RotateEntity PlayBoard,0,0,270:setdirection=3
				If vonrichtung="R" Then RotateEntity PlayBoard,0,0,90:setdirection=3
			Case 4,2;4way oder L+R
				;L+R 	LUR v 0 - OLU < 1 - ROL ^ 2 - URO > 3
				If (EntityRoll(PlayBoard)>90 And EntityRoll(PlayBoard)<92) Or (EntityRoll(PlayBoard)<90 And EntityRoll(PlayBoard)>88) Then RotateEntity PlayBoard,0,0,90
				If (EntityRoll(PlayBoard)<-90 And EntityRoll(PlayBoard)>-92) Or (EntityRoll(PlayBoard)>-90 And EntityRoll(PlayBoard)<-88) Then RotateEntity PlayBoard,0,0,-90
				LOrR=Rnd(1,2)
				setdirection=LOrR
				If Ground=2 Then
					If darfRichtung=0 And vonrichtung="L" Then setdirection=2
					If darfRichtung=0 And vonrichtung="O" Then RotateEntity PlayBoard,0,0,180:setdirection=3
					If darfRichtung=0 And vonrichtung="R" Then setdirection=1
					If darfRichtung=0 And vonrichtung="U" Then setdirection=LOrR
					If darfRichtung=3 And vonrichtung="L" Then setdirection=LOrR
					If darfRichtung=3 And vonrichtung="O" Then setdirection=2
					If darfRichtung=3 And vonrichtung="R" Then RotateEntity PlayBoard,0,0,90:setdirection=3
					If darfRichtung=3 And vonrichtung="U" Then setdirection=1
					If darfRichtung=2 And vonrichtung="L" Then setdirection=1
					If darfRichtung=2 And vonrichtung="O" Then setdirection=LOrR
					If darfRichtung=2 And vonrichtung="R" Then setdirection=2
					If darfRichtung=2 And vonrichtung="U" Then RotateEntity PlayBoard,0,0,0:setdirection=3
					If darfRichtung=1 And vonrichtung="L" Then RotateEntity PlayBoard,0,0,270:setdirection=3
					If darfRichtung=1 And vonrichtung="O" Then setdirection=1
					If darfRichtung=1 And vonrichtung="R" Then setdirection=LOrR
					If darfRichtung=1 And vonrichtung="U" Then setdirection=2
				EndIf
			Case 1;Kurve
				;Stop ;OL / 2    OR \ 3    UL ` 1   UR  0
				If (EntityRoll(PlayBoard)>90 And EntityRoll(PlayBoard)<92) Or (EntityRoll(PlayBoard)<90 And EntityRoll(PlayBoard)>88) Then RotateEntity PlayBoard,0,0,90
				If (EntityRoll(PlayBoard)<-90 And EntityRoll(PlayBoard)>-92) Or (EntityRoll(PlayBoard)>-90 And EntityRoll(PlayBoard)<-88) Then RotateEntity PlayBoard,0,0,-90
				If darfRichtung=0 And vonrichtung="O" Then RotateEntity PlayBoard,0,0,180:setdirection=3
				If darfRichtung=0 And vonrichtung="R" Then RotateEntity PlayBoard,0,0,90:setdirection=3
				If darfRichtung=0 And vonrichtung="U" Then setdirection=1
				If darfRichtung=0 And vonrichtung="L" Then setdirection=2
				If darfRichtung=1 And vonrichtung="O" Then RotateEntity PlayBoard,0,0,180:setdirection=3
				If darfRichtung=1 And vonrichtung="R" Then setdirection=1
				If darfRichtung=1 And vonrichtung="U" Then setdirection=2
				If darfRichtung=1 And vonrichtung="L" Then RotateEntity PlayBoard,0,0,270:setdirection=3
				If darfRichtung=2 And vonrichtung="O" Then setdirection=1
				If darfRichtung=2 And vonrichtung="R" Then setdirection=2
				If darfRichtung=2 And vonrichtung="U" Then RotateEntity PlayBoard,0,0,0:setdirection=3
				If darfRichtung=2 And vonrichtung="L" Then RotateEntity PlayBoard,0,0,270:setdirection=3
				If darfRichtung=3 And vonrichtung="O" Then setdirection=2
				If darfRichtung=3 And vonrichtung="R" Then RotateEntity PlayBoard,0,0,90:setdirection=3
				If darfRichtung=3 And vonrichtung="U" Then RotateEntity PlayBoard,0,0,0:setdirection=3
				If darfRichtung=3 And vonrichtung="L" Then setdirection=1
			Case 6,3;Gerade
				If (EntityRoll(PlayBoard)>90 And EntityRoll(PlayBoard)<92) Or (EntityRoll(PlayBoard)<90 And EntityRoll(PlayBoard)>88) Then RotateEntity PlayBoard,0,0,90
				If (EntityRoll(PlayBoard)<-90 And EntityRoll(PlayBoard)>-92) Or (EntityRoll(PlayBoard)>-90 And EntityRoll(PlayBoard)<-88) Then RotateEntity PlayBoard,0,0,-90
				If darfRichtung=0 And vonrichtung="O" Then RotateEntity PlayBoard,0,0,180:setdirection=3
				If darfRichtung=0 And vonrichtung="U" Then RotateEntity PlayBoard,0,0,0:setdirection=3
				If darfRichtung=1 And vonrichtung="L" Then RotateEntity PlayBoard,0,0,270:setdirection=3
				If darfRichtung=1 And vonrichtung="R" Then RotateEntity PlayBoard,0,0,90:setdirection=3
		End Select
	EndIf
	Select Ground
		Case 0,3
			MoveEntity PlayBoard,0,1,0
		Case 1,2,4
			If setdirection=1 Then TurnEntity PlayBoard,0,0,2.8:MoveEntity PlayBoard,0,1,0;links
			If setdirection=2 Then TurnEntity PlayBoard,0,0,-2.8:MoveEntity PlayBoard,0,1,0;rechts
			If setdirection=3 Then MoveEntity PlayBoard,0,1,0;gerade
		Default
			MoveEntity PlayBoard,0,1,0
	End Select	
	If Ground<>GroundDebug$ Then
		GroundDebug=Ground
	EndIf
	;Select Ground
End Function
Function LoadLevel(file$)
;Stop
	LevelFile=ReadFile(file)
	;Spielfeld(x,y,1)=x koordinate 1-11	
	;Spielfeld(x,y,2)=y koordinate 1-11
	;Spielfeld(x,y,3)=Typ Gerade(0) Kurve(1) L+R(2) Kreuzung(3) 4way(4) Frei(5) Gerade(6)
	;Spielfeld(x,y,4)=Orientation waagerecht(1) senkrecht(2) / bzw 0Grad (0) 90Grad (1) 180Grad(2) 270Grad(3)
	;Spielfeld(x,y,5)=Sondertyp Keiner(0) Start(1) Ziel(2) Point1(3) Point2(4) Point3(5) Point4(6) Point5(7)
	StartX=-1
	StartY=-1
	Repeat
		Liner$=ReadLine(LevelFile)
		X=0
		If Not Instr(Liner$,";")=1 Then
			For ReadLevel=1 To Len(Liner)
				Spielfeld(X,Y,0)=X*40
				Spielfeld(X,Y,1)=Y*40
				Sign$=Mid$(Liner,ReadLevel,1)
				Select Sign
					Case "."
						Spielfeld(X,Y,3)="5"
						X=X+1
					Case "|","1","2","3","4","5","-","=","6","7","8","9","0","Z","z","S","s"
						Spielfeld(X,Y,3)="6"
						Select Sign
							Case "Z","z"
								Extra=2
							Case "S","s"
								Extra=1
							Case "1","6"
								Extra=3
							Case "2","7"
								Extra=4
							Case "3","8"
								Extra=5
							Case "4","9"
								Extra=6
							Case "5","0"
								Extra=7
							Default
								Extra=0
						End Select
						Spielfeld(X,Y,2)=Create("Gerade",0,128,0,Extra,0.5)
						PositionEntity Spielfeld(X,Y,2),Spielfeld(X,Y,0),Spielfeld(X,Y,1),0
						Spielfeld(X,Y,4)=1
						Select Sign
							Case "S","s"
								Spielfeld(X,Y,5)=1
								If StartX>=0 Then startrnd=Rnd(0,1)
								If startrnd=0 Then StartX=X:StartY=Y
								If Sign="s" Then
									RotateEntity PlayBoard,0,0,90
									TurnEntity Spielfeld(X,Y,2),0,0,90
									Spielfeld(X,Y,4)=0
								EndIf
							Case "Z","z"
								Spielfeld(X,Y,5)=2
								EndX=X
								EndY=Y
								If Sign="z" Then
									Spielfeld(X,Y,4)=0
									TurnEntity Spielfeld(X,Y,2),0,0,90
								EndIf
							Case "-","="
								TurnEntity Spielfeld(X,Y,2),0,0,90
								Spielfeld(X,Y,4)=0
							Case "1","2","3","4","5"
								If Sign="1" Then Spielfeld(X,Y,5)=3
								If Sign="2" Then Spielfeld(X,Y,5)=4
								If Sign="3" Then Spielfeld(X,Y,5)=5
								If Sign="4" Then Spielfeld(X,Y,5)=6
								If Sign="5" Then Spielfeld(X,Y,5)=7
							Case "6","7","8","9"
								If Sign="6" Then Spielfeld(X,Y,5)=3
								If Sign="7" Then Spielfeld(X,Y,5)=4
								If Sign="8" Then Spielfeld(X,Y,5)=5
								If Sign="9" Then Spielfeld(X,Y,5)=6
								TurnEntity Spielfeld(X,Y,2),0,0,90
								Spielfeld(X,Y,4)=0
							Case "0"
								Spielfeld(X,Y,5)=7
								TurnEntity Spielfeld(X,Y,2),0,0,90
								Spielfeld(X,Y,4)=0
						End Select
						X=X+1
					Case "","`","/","\"
						Spielfeld(X,Y,2)=Create("Kurve")
						Spielfeld(X,Y,3)="1"
						If Sign="" Then Spielfeld(X,Y,4)=0:RotateEntity Spielfeld(X,Y,2),0,0,0
						If Sign="`" Then Spielfeld(X,Y,4)=1:RotateEntity Spielfeld(X,Y,2),0,0,90
						If Sign="/" Then Spielfeld(X,Y,4)=2:RotateEntity Spielfeld(X,Y,2),0,0,180
						If Sign="\" Then Spielfeld(X,Y,4)=3:RotateEntity Spielfeld(X,Y,2),0,0,270
						PositionEntity Spielfeld(X,Y,2),Spielfeld(X,Y,0),Spielfeld(X,Y,1),0
						X=X+1
					Case "^","v","<",">"
						Spielfeld(X,Y,2)=Create("R+L")
						Spielfeld(X,Y,3)="2"
						If Sign="v" Then Spielfeld(X,Y,4)=0:RotateEntity Spielfeld(X,Y,2),0,0,0
						If Sign="<" Then Spielfeld(X,Y,4)=1:RotateEntity Spielfeld(X,Y,2),0,0,90
						If Sign="^" Then Spielfeld(X,Y,4)=2:RotateEntity Spielfeld(X,Y,2),0,0,180
						If Sign=">" Then Spielfeld(X,Y,4)=3:RotateEntity Spielfeld(X,Y,2),0,0,270
						PositionEntity Spielfeld(X,Y,2),Spielfeld(X,Y,0),Spielfeld(X,Y,1),0
						X=X+1
					Case "+"
						Spielfeld(X,Y,2)=Create("Kreuzung")
						Spielfeld(X,Y,3)="3"
						Spielfeld(X,Y,4)="9"
						PositionEntity Spielfeld(X,Y,2),Spielfeld(X,Y,0),Spielfeld(X,Y,1),0
						X=X+1
					Case "O"
						Spielfeld(X,Y,2)=Create("4way")
						Spielfeld(X,Y,3)="4"
						PositionEntity Spielfeld(X,Y,2),Spielfeld(X,Y,0),Spielfeld(X,Y,1),0
						X=X+1
				End Select
				
				If X=9 Then Exit
			Next
			Y=Y+1	
		EndIf
	Until Y=11
	Repeat
		RWS$=ReadLine(LevelFile)
		W=W+1
		Welle(W,0)=Len(RWS)
		DebugLog "Welle("+W+",0)="+Welle(W,0)+" Wellenlnge"
		Welle(W,1)=RWS
	Until Eof(LevelFile) Or W=20
	NextLoad=Mid(Welle(1,1),1,1)
	WellenText$=Welle(1,1)
	CountWelle=1
End Function
Function Movement(camera,speedfast#=3,speedslow#=1)
  mspeedx=MouseXSpeed()
  mspeedy=MouseYSpeed()
  msensivityX#=mspeedx/2
  msensivityY#=mspeedy/2
If mspeedy<>0 Then TurnEntity camera,msensivityy,0 ,0
If mspeedx<>0 Then TurnEntity camera,0,-msensivityX,0
  If KeyDown(54) Or KeyDown(42) Then movespeed#=speedslow Else movespeed=speedfast
  If KeyDown(32)=True Then MoveEntity camera, movespeed, 0, 0;205
  If KeyDown(30)=True Then MoveEntity camera,-movespeed, 0, 0;203
  If KeyDown(201)=True Then MoveEntity camera, 0, movespeed, 0;201
  If KeyDown(209)=True Then MoveEntity camera, 0,-movespeed, 0;209
  If KeyDown(31)=True Then MoveEntity camera, 0, 0,-movespeed;208
  If KeyDown(17)=True Then MoveEntity camera, 0, 0, movespeed;200
  MoveMouse 512,384
End Function
Function movement3(camera,invertx,inverty)
	Local mturnx#,mturny#
	mspeedx=MouseXSpeed()
	mspeedy=MouseYSpeed()
	mturnx=mspeedx/MouseSensivity
	mturny=mspeedy/MouseSensivity
	If invertx=1 Then mturnx=-mturnx
	If inverty=1 Then mturny=-mturny
	MoveEntity camera,mturnx,mturny,0
	RotateEntity camera,EntityPitch(camera),EntityYaw(camera),180
End Function
Function Create(item$,tcolr=0,tcolg=0,tcolb=0,Special=0,trans#=0)
	Local All[99]
	ItemCount=ItemCount+1
	
	All[ItemCount]=CreateMesh()
	EntityFX All[ItemCount],2+32+8
	Select item
		Case "Gerade"
			part1=CreateCube()
			part2=CreateCube()
			part3=CreateCube()
			part4=CreateCube()
			part5=CreateCube()
			ScaleMesh part1,1,20,2
			ScaleMesh part2,1,20,2
			ScaleMesh part3,15,3,1
			ScaleMesh part4,15,3,1
			ScaleMesh part5,15,3,1
			PositionMesh part1,-10,0,0
			PositionMesh part2, 10,0,0
			PositionMesh part3,0,-13,0
			PositionMesh part4,0,  0,0
			PositionMesh part5,0, 13,0
			AddMesh part1,All[ItemCount]
			AddMesh part2,All[ItemCount]
			AddMesh part3,All[ItemCount]
			AddMesh part4,All[ItemCount]
			AddMesh part5,All[ItemCount]
			FreeEntity part1
			FreeEntity part2
			FreeEntity part3
			FreeEntity part4
			FreeEntity part5
			For i=0 To 47
				VertexColor(GetSurface(All[ItemCount],1),i,80,80,80)
			Next
			For i=48 To 119
				VertexColor(GetSurface(All[ItemCount],1),i,185,125,85)
			Next
			If Special=1 Then
				For i=72 To 95
					VertexColor(GetSurface(All[ItemCount],1),i,0,255,0)
				Next
			ElseIf Special=2 Then
				For i=72 To 95
					VertexColor(GetSurface(All[ItemCount],1),i,255,0,0)
				Next
			ElseIf Special>=3 Then
				part6=CreateCube()
				part7=CreateCube()
				part8=CreateCube()
				ScaleMesh part6,2,4,10
				ScaleMesh part7,2,4,10
				ScaleMesh part8,18,4,2
				PositionMesh part6,-13.5,0,-11
				PositionMesh part7,13.5,0,-11
				PositionMesh part8,0,0,-23
				AddMesh part6,All[ItemCount]
				AddMesh part7,All[ItemCount]
				AddMesh part8,All[ItemCount]
				FreeEntity part6
				FreeEntity part7
				FreeEntity part8
				If Special=3 Then 
					For i=120 To 191
						VertexColor(GetSurface(All[ItemCount],1),i,255,0,0)
					Next
				ElseIf Special=4 Then
					For i=120 To 191
						VertexColor(GetSurface(All[ItemCount],1),i,0,255,0)
					Next
				ElseIf Special=5 Then
					For i=120 To 191
						VertexColor(GetSurface(All[ItemCount],1),i,0,0,255)
					Next
				ElseIf Special=6 Then
					For i=120 To 191
						VertexColor(GetSurface(All[ItemCount],1),i,255,255,0)
					Next
				ElseIf Special=7 Then
					For i=120 To 191
						VertexColor(GetSurface(All[ItemCount],1),i,0,255,255)
					Next
				EndIf
			EndIf
		Case "Kreuzung"
			part1=CreateCube()
			part2=CreateCube()
			part3=CreateCube()
			part4=CreateCube()
			part6=CreateCube()
			part7=CreateCube()
			ScaleMesh part1,1,20,2
			ScaleMesh part2,1,20,2
			ScaleMesh part3,20,3,1
			ScaleMesh part4,20,3,1
			ScaleMesh part6,20,1,2
			ScaleMesh part7,20,1,2
			PositionMesh part1,-10,0,0
			PositionMesh part2, 10,0,0
			PositionMesh part3,  0,0,0
			PositionMesh part4,  0,0,0
			PositionMesh part6,0,-10,0
			PositionMesh part7,0, 10,0
			RotateMesh part3,0,0,45
			RotateMesh part4,0,0,-45
			AddMesh part1,All[ItemCount]
			AddMesh part2,All[ItemCount]
			AddMesh part3,All[ItemCount]
			AddMesh part4,All[ItemCount]
			AddMesh part6,All[ItemCount]
			AddMesh part7,All[ItemCount]
			FreeEntity part1
			FreeEntity part2
			FreeEntity part3
			FreeEntity part4
			FreeEntity part6
			FreeEntity part7
			For i=0 To 47
				VertexColor(GetSurface(All[ItemCount],1),i,80,80,80)
			Next
			For i=48 To 95
				VertexColor(GetSurface(All[ItemCount],1),i,185,125,85)
			Next
			For i=96 To 143
				VertexColor(GetSurface(All[ItemCount],1),i,80,80,80)
			Next
		Case "Kurve"
			part1=CreateCylinderPart(11,9,90,Detail)
			part2=CreateCylinderPart(31,29,90,Detail)
			ScaleMesh part1,1,2,1
			ScaleMesh part2,1,2,1
			AddMesh part1,All[ItemCount]
			AddMesh part2,All[ItemCount]
			RotateMesh All[ItemCount],90,90,90
			PositionMesh All[ItemCount],20,20,0
			FreeEntity part1
			FreeEntity part2
			For i=0 To CountVertices(GetSurface(All[ItemCount],1))
				VertexColor(GetSurface(All[ItemCount],1),i,80,80,80)
			Next
		Case "R+L"
			part1=CreateCylinderPart(11,9,90,Detail)
			part2=CreateCylinderPart(31,29,90,Detail)
			part3=CreateCylinderPart(11,9,90,Detail)
			part4=CreateCylinderPart(31,29,90,Detail)
			ScaleMesh part1,1,2,1
			ScaleMesh part2,1,2,1
			ScaleMesh part3,1,2,1
			ScaleMesh part4,1,2,1
			PositionMesh part1,-20,0,-20
			PositionMesh part2,-20,0,-20
			PositionMesh part3,-20,0,-20
			PositionMesh part4,-20,0,-20
			RotateMesh part1,90,90,90
			RotateMesh part2,90,90,90
			RotateMesh part3,90,90,270
			RotateMesh part4,90,90,270
			RotateMesh All[ItemCount],90,90,90
			AddMesh part1,All[ItemCount]
			AddMesh part2,All[ItemCount]
			AddMesh part3,All[ItemCount]
			AddMesh part4,All[ItemCount]
			FreeEntity part1
			FreeEntity part2
			FreeEntity part3
			FreeEntity part4
			For i=0 To CountVertices(GetSurface(All[ItemCount],1))
				VertexColor(GetSurface(All[ItemCount],1),i,80,80,80)
			Next
		Case "4way"
			part1=CreateCylinderPart(11,9,90,Detail)
			part2=CreateCylinderPart(31,29,90,Detail)
			part3=CreateCylinderPart(11,9,90,Detail)
			part4=CreateCylinderPart(31,29,90,Detail)
			ScaleMesh part1,1,2,1
			ScaleMesh part2,1,2,1
			ScaleMesh part3,1,2,1
			ScaleMesh part4,1,2,1
			PositionMesh part1,-20,0,-20
			PositionMesh part2,-20,0,-20
			PositionMesh part3,-20,0,-20
			PositionMesh part4,-20,0,-20
			RotateMesh part1,90,90,90
			RotateMesh part2,90,90,90
			RotateMesh part3,90,90,270
			RotateMesh part4,90,90,270
			RotateMesh All[ItemCount],90,90,90
			AddMesh part1,All[ItemCount]
			AddMesh part2,All[ItemCount]
			AddMesh part3,All[ItemCount]
			AddMesh part4,All[ItemCount]
			FreeEntity part1
			FreeEntity part2
			FreeEntity part3
			FreeEntity part4
			cm=CopyMesh(All[ItemCount],All[ItemCount])
			RotateMesh cm,0,0,180
			AddMesh cm,All[ItemCount]
			FreeEntity cm
			For i=0 To CountVertices(GetSurface(All[ItemCount],1))
				VertexColor(GetSurface(All[ItemCount],1),i,80,80,80)
			Next
	End Select
	plate=CreateCube()
	For i=0 To CountVertices(GetSurface(Plate,1))
		VertexColor(GetSurface(Plate,1),i,tcolr,tcolg,tcolb,trans)
	Next
	ScaleMesh plate,20,20,1
	PositionMesh plate,0,0,2
	AddMesh plate,All[ItemCount]
	FreeEntity plate
	EntityPickMode All[ItemCount],2
	Return All[ItemCount]
End Function
Function CreateCylinderPart(aussenradius,innenradius,degrees,detail=80);1-100 empfohlen nicht unter 30
	detail=101-detail
	CP=CreatePivot()
	PositionEntity CP,0,-1,0
	mesh=CreateMesh()
	surface=CreateSurface(mesh)
	Local VertexPoints[1440]
	For I=0 To degrees/detail
		MoveEntity CP,aussenradius,0,0
		VertexPoints[I]=AddVertex(surface,EntityX(CP),EntityY(CP),EntityZ(CP))
		MoveEntity CP,-(aussenradius-innenradius),0,0
		VertexPoints[I+(360)]=AddVertex(surface,EntityX(CP),EntityY(CP),EntityZ(CP))
		MoveEntity CP,-innenradius,0,0
		TurnEntity CP,0,detail,0
	Next
	PositionEntity CP,0,1,0
	RotateEntity CP,0,0,0
	For I=720 To 720+(degrees/detail)
		MoveEntity CP,aussenradius,0,0
		VertexPoints[I]=AddVertex(surface,EntityX(CP),EntityY(CP),EntityZ(CP))
		MoveEntity CP,-(aussenradius-innenradius),0,0
		VertexPoints[I+360]=AddVertex(surface,EntityX(CP),EntityY(CP),EntityZ(CP))
		MoveEntity CP,-innenradius,0,0
		TurnEntity CP,0,detail,0
	Next
	For I=0 To (degrees/detail)-1
		AddTriangle(surface,VertexPoints[I],VertexPoints[I+1],VertexPoints[I+1+360])
		AddTriangle(surface,VertexPoints[I],VertexPoints[I+1+360],VertexPoints[I+360])
		AddTriangle(surface,VertexPoints[I+720],VertexPoints[I+1+360+720],VertexPoints[I+1+720])
		AddTriangle(surface,VertexPoints[I+720],VertexPoints[I+360+720],VertexPoints[I+1+360+720])
		AddTriangle(surface,VertexPoints[I],VertexPoints[I+720+1],VertexPoints[I+1])
		AddTriangle(surface,VertexPoints[I],VertexPoints[I+720],VertexPoints[I+720+1])
		AddTriangle(surface,VertexPoints[I+360],VertexPoints[I+360+1],VertexPoints[I+360+1+720])
		AddTriangle(surface,VertexPoints[I+360],VertexPoints[I+360+1+720],VertexPoints[I+360+720])
	Next
	
	AddTriangle(surface,VertexPoints[0],VertexPoints[360],VertexPoints[1080])
	AddTriangle(surface,VertexPoints[0],VertexPoints[1080],VertexPoints[720])
	
	AddTriangle(surface,VertexPoints[0+(degrees/detail)],VertexPoints[1080+(degrees/detail)],VertexPoints[360+(degrees/detail)])
	AddTriangle(surface,VertexPoints[0+(degrees/detail)],VertexPoints[720+(degrees/detail)],VertexPoints[1080+(degrees/detail)])
	
	Return mesh
End Function
;
;~IDEal Editor Parameters:
;~F#1C0#1D0
;~B#18#63#A2#B1#C0#CF#DE#133#1BD
;~C#Blitz3D